<?php
//--------------------------------------------------------------------
// *** TitleNavi ***
// LAST UPDATE: 2009/05/30
// Version    : 1.23
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// viewer.php
//
//--------------------------------------------------------------------

if ($blogn_get_e) {
	$blogn_mod_titlenav_nextbackurl = blogn_mod_db_log_nextback_url($blogn_user, $blogn_get_e);
	$blogn_skin = blogn_mod_titlenav_output($blogn_user, $blogn_skin, $blogn_mod_titlenav_nextbackurl);
} else {
	$blogn_skin = str_replace("{TNV_NEXT}", "", $blogn_skin);
	$blogn_skin = str_replace("{TNV_BACK}", "", $blogn_skin);
}

/* ----- リンク付きタイトル出力 ----- */
function blogn_mod_titlenav_output($user, $skin, $nextbackurl) {
	if ($nextbackurl[0]) {
		$inifile = BLOGN_MODDIR.'titlenav/config.cgi';
		$inis = file($inifile);
		list($ini["back_pre"], $ini["back_pst"], $ini["next_pre"], $ini["next_pst"], $length, $trimmaker, $notitle) = explode(",", $inis[0]);
		
		if ($nextbackurl[1] != -1) {
			$nextlog = blogn_mod_db_log_load_for_entory($user, $nextbackurl[1]);
			if ($nextlog[0]) {
				$nexttitle = $length ? blogn_mod_titlenav_cuttitle($nextlog[1]["title"], $length, $trimmaker) : $nextlog[1]["title"] ;
				if (!$nexttitle) $nexttitle = $notitle;
				if (BLOGN_MOBILE_KEY || !$length) {
					$skin = str_replace("{TNV_NEXT}", '<a href="index.php?e='.$nextbackurl[1].'">'.$ini["next_pre"].$nexttitle.$ini["next_pst"].'</a>', $skin);
				} else {
					$skin = str_replace("{TNV_NEXT}", '<a href="index.php?e='.$nextbackurl[1].'" title="'.$nextlog[1]["title"].'">'.$ini["next_pre"].$nexttitle.$ini["next_pst"].'</a>', $skin);
				}
				$skin = preg_replace("/\{NEXTPAGE[\w\W]*?\}[\w\W]+?\{\/NEXTPAGE\}/", "", $skin);
			}
		}
		if ($nextbackurl[2] != -1) {
			$backlog = blogn_mod_db_log_load_for_entory($user, $nextbackurl[2]);
			if ($backlog[0]) {
				$backtitle = $length ? blogn_mod_titlenav_cuttitle($backlog[1]["title"], $length, $trimmaker) : $backlog[1]["title"] ;
				if (!$backtitle) $backtitle = $notitle;
				if (BLOGN_MOBILE_KEY || !$length) {
					$skin = str_replace("{TNV_BACK}", '<a href="index.php?e='.$nextbackurl[2].'">'.$ini["back_pre"].$backtitle.$ini["back_pst"].'</a>', $skin);
				} else {
					$skin = str_replace("{TNV_BACK}", '<a href="index.php?e='.$nextbackurl[2].'" title="'.$backlog[1]["title"].'">'.$ini["back_pre"].$backtitle.$ini["back_pst"].'</a>', $skin);
				}
				$skin = preg_replace("/\{BACKPAGE[\w\W]*?\}[\w\W]+?\{\/BACKPAGE\}/", "", $skin);
			}
		}
	}
	$skin = str_replace("{TNV_NEXT}", "", $skin);
	$skin = str_replace("{TNV_BACK}", "", $skin);
	return $skin;
}

/* ----- タイトル省略 ----- */
function blogn_mod_titlenav_cuttitle($str, $maxlength, $trimmaker) {
	if (extension_loaded("mbstring")) {
		$str = mb_strimwidth($str, 0, $maxlength, $trimmaker, "UTF-8");
	} else {
		if (strlen($str) > $maxlength)	{
			$str = substr($str, 0, $maxlength);
			// ----- multi bytes (utf-8)
			$str = preg_replace("/[\xC0-\xFD]$/", "" , $str); 
			$str = preg_replace("/[\xE0-\xFD][\x80-\xBF]$/", "", $str); 
			$str = preg_replace("/[\xE0-\xFD][\x80-\xBF]{2}$/" ,"", $str); 
			// -----
			$str .= $trimmaker;
		}
	}
	return $str;
}
?>